/*****************************************************************************
* Util.c - vWFNg̃[eBeB֐Q
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <rt.h>

#include "EtherCAT_RSI.h"

/*****************************************************************************
* FUNCTION:		Catalog
*
* PARAMETERS:	1. ǂ̃vWFNgnhgp邩vWFNgnhŎw
*				2. J^OIuWFNgnhw
*				3. J^O閼(pp14ȓ)w
*
* RETURNS:		BOOL Ӗ܂
*
* DESCRIPTION:	^ꂽ̂łɑ݂ĂAvZX[gvZX̏ꍇ
*				ŁAɂłɑ݂閼̂AsȃIuWFNgĂꍇ
*				ȏ𖞂ƂA݂Ă閼͈̂x폜܂B
\*****************************************************************************/
BOOL				Catalog(
	RTHANDLE			hProcess,
	RTHANDLE			hObject,
	LPSTR				lpszName)
{
	RTHANDLE		hOld;

	if (CatalogRtHandle(hProcess, hObject, lpszName))
		return TRUE;

	// 悭G[o܂
	if (((hOld = LookupRtHandle(hProcess, lpszName, NO_WAIT)) != BAD_RTHANDLE) &&
		(GetRtHandleType(hOld) == INVALID_TYPE))
	{
		// ÂGg폜čēx݂܂
		if (UncatalogRtHandle(hProcess, lpszName))
			return (CatalogRtHandle(hProcess, hObject, lpszName));
	}
	return FALSE;
}

/*****************************************************************************
* FUNCTION:   Cleanup (local function)
*
* DESCRIPTION:
*  Xbhɑ΂IɏI悤ɒʒm;
*  ʒmXbh݂ꍇA폜
*  ꂽ̑̃IuWFNg폜B
\*****************************************************************************/
void				Cleanup(void)
{
	int				i;

	// N[Abvł邱Ƃ܂
	gInit.state		= CLEANUP_BUSY;
	gInit.bShutdown = TRUE;

#ifdef _DEBUG
  fprintf(stderr, "EtherCAT_RSI started cleaning up\n");
#endif

	// Xbh̏Iő 100 x 1bҋ@܂
	// TODO ҋ@Ԃ̒ɂāA{l 100ύXĂ
	for (i = 0; i < 100; i++)
	{
		// ̈ÃXe[ggɂāASANDeXg܂
		if (NULL_RTHANDLE == gInit.htPoll1)
			break;
		RtSleep(100);
	}

	// |[OXbhI܂
	if (NULL_RTHANDLE != gInit.htPoll1)
		if (!DeleteRtThread(gInit.htPoll1))
			Fail("Cannot delete poll thread Poll1");

	// [gvZXJ^Ô폜܂
	if (gInit.bCataloged)
		if (!UncatalogRtHandle(hRootProcess, "EtherCAT_RSI"))
			Fail("Cannot remove my own name");

#ifdef _DEBUG
	fprintf(stderr, "EtherCAT_RSI finished cleaning up\n");
#endif

	// I
	exit(0);
}

/*****************************************************************************
* FUNCTION:     	Fail
*
* PARAMETERS:   	printfƓl̃p[^҂܂
*
* DESCRIPTION:
*  fobO[hɂăbZ[Wvg܂BVCǉ
*  XgG[R[hvg܂B̌svZX͍폜܂:
*  JgXbhCXbh̏ꍇAړIɏI܂B
*  JgXbhCXbhȊȌꍇAIv𑗂
*  ̓R[Xbhɖ߂܂
\*****************************************************************************/
void				Fail(
	LPSTR				lpszMessage, ...)
{
	EXCEPTION		eh;
	RTHANDLE		hDelMbx;
	DWORD			dwTerminate;

#ifdef _DEBUG
	va_list			ap;

	va_start(ap, lpszMessage);
	vfprintf(stderr, lpszMessage, ap);
	va_end(ap);
	fprintf(stderr, "\nError nr=%x\n", GetLastRtError());
#endif

	// OCCpɃ^[邱ƂmFĂ
	GetRtExceptionHandlerInfo(THREAD_HANDLER, &eh);
	eh.ExceptionMode = 0;
	SetRtExceptionHandler(&eh);

	// JnOłꍇAɏI܂
	if (BEFORE_INIT == gInit.state)
		exit(0);

	if (gInit.hMain == GetRtThreadHandles(THIS_THREAD))
	{
		// CXbhłꍇ:
		// łꍇACleanups܂
		if (INIT_BUSY == gInit.state)
			Cleanup();  // ԋp܂

		// CXbh:sĂȂ߁A^[Ƃ܂
		return;
	}

	// CXbhȊO:
	// CXbhɑ΂N[Abvv܂
	// (폜v[𑗂)G[͖܂B
	hDelMbx			= LookupRtHandle(NULL_RTHANDLE, "R?EXIT_MBOX", 5000);
	dwTerminate		= TERMINATE;
	SendRtData(hDelMbx, &dwTerminate, 4);
}

/*****************************************************************************
*
* FUNCTION:		UsecsToKticks
*
* PARAMETERS:	1. ʕbӖ鐔l
*
* RETURNS:		჌xeBbNl
*
* DESCRIPTION:	^ꂽWAIT_FOREVER̎AWAIT_FOREVERԋp܂B
*				͒჌x`bNlŐ؂グ܂B
\*****************************************************************************/
DWORD				UsecsToKticks(
	DWORD				dwUsecs)
{
	if (dwUsecs == WAIT_FOREVER)
		return WAIT_FOREVER;

	return (dwUsecs + dwKtickInUsecs - 1) / dwKtickInUsecs;
}
