/*****************************************************************************
* Poll1.c - |[Ô߂̃W[ Poll1
\*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <rt.h>
#include <EhApi.h>

#include "EtherCAT_RSI.h"
#include "miniRSI_Ec.h"


//******************************************************************************
// @\Fw軲ނ؂۹ĂāARTقg۾ɶ۸ނ܂B
//		dwSize		Fmۂػށi޲ĒPʁj
//		chCtlgName	F۸ޖ̂̎w
//		chErrMsg	Fװ\MSGe
//		߂l		Fmۂ؂̐擪ڽԂ܂B
//******************************************************************************
void	*fnSetMemory( DWORD dwSize, char *chCtlgName, char *chErrMsg )
{
	void	*pvoTbl;
	RTHANDLE rtTbl;

	dwSize = ((dwSize + 4095) / 4096) * 4096;				// 4KbytePʂɒ
	pvoTbl = AllocateRtMemory( dwSize );					// ؂̊mہF4096ByteP
	if( pvoTbl == NULL ) Fail("E$ Cannot allocate shared memory [%s] ", chErrMsg );
	memset( pvoTbl, 0, dwSize );							// mۂ؂̸ر

	// << RT/NTԋLِ>>
	if(( rtTbl = CreateRtMemoryHandle( pvoTbl , dwSize)) == BAD_RTHANDLE) 
		Fail("E$ CreateRtMemoryHandle Fail  [%s] ", chErrMsg );

	// RT/NTԋLق̶۸
	if (!Catalog(GetRtThreadHandles(THIS_PROCESS), rtTbl, chCtlgName))
		Fail("E$ Cannot catalog process name[%s] ", chCtlgName );

	return(pvoTbl);
}	// end of fnSetMemory()


/*****************************************************************************
* FUNCTION:		Poll1
* DESCRIPTION:
*   |[OXbh Poll1
\*****************************************************************************/
void				Poll1(
	void*				param)
{
	int		inPortNum = 0;
	int		inBaudRate = 19200;
	BYTE	cConfig = PARITY_NONE | STOPBIT_ONE | DATABIT_EIGHT;
	int		inRet;
	char	chSendBuff[128];
	//char	chRecvBuff[128];
	BYTE	cDummy = 0;
	int		inRecvSize=0;
	DWORD	dwTimeout = 1000;
	char	chBuf[128];
	int		inNo;
	char	*pRecvBuff;


	// {XbhĂ邱Ƃo^
	gInit.htPoll1	= GetRtThreadHandles(THIS_THREAD);

	// XbhJ^OAs͖
	Catalog(NULL_RTHANDLE, gInit.htPoll1, "TPoll1");

	// Mf[^i[TB𐶐
	pRecvBuff = fnSetMemory(1024, "TB_RECV_BUFF", "TB_RECV_BUFF");

	while (!gInit.bShutdown)
	{
		memset(chBuf, 0, sizeof(chBuf));
		printf("cmd >> ");
		gets_s(chBuf, sizeof(chBuf));
		inNo = atoi(chBuf);		// ԍݒ肵܂

		switch( inNo ){
			// -------------------------------------------------------------------------------------------
			case 99:		// Program end
				printf("I$ program end!! \n");
				exit(0);
				break;

			// -------------------------------------------------------------------------------------------
			case 1:			// EhOpen()
				inRet = Tiny_RSEhOpen();
				printf("I$ Tiny_RSEhOpen() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 2:			// EhClose()
				inRet = Tiny_RSEhClose();
				printf("I$ Tiny_RSEhClose() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 3:			// EhRqState()
				inRet = Tyny_RSEhRqState(MST_OPERATIONAL);
				printf("I$ Tyny_RSEhRqState() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 10:		// RSinit()
				// `lԍ
				printf("input CH(0-3) >> ");
				gets_s(chBuf, sizeof(chBuf));
				inPortNum = atoi(chBuf);

				// {[[g
				printf("input Baudrate >> ");
				gets_s(chBuf, sizeof(chBuf));
				inBaudRate = atoi(chBuf);

				// ʐMtO
				printf("input Config >> ");
				gets_s(chBuf, sizeof(chBuf));
				cConfig = (BYTE)atoi(chBuf);

				inRet = Tiny_RSinit( inPortNum, inBaudRate, cConfig);
				printf("I$ Tiny_RSinit() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 11:		// RSterm()
				// `lԍ
				printf("input CH(0-3) >> ");
				gets_s(chBuf, sizeof(chBuf));
				inPortNum = atoi(chBuf);

				inRet = Tiny_RSterm( inPortNum);
				printf("I$ Tiny_RSterm() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 12:		// RSsend()
				// `lԍ
				printf("input CH(0-3) >> ");
				gets_s(chBuf, sizeof(chBuf));
				inPortNum = atoi(chBuf);

				inRet = Tiny_RSsend( inPortNum, &chSendBuff[0], sizeof(chSendBuff) );
				printf("I$ Tiny_RSsend() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 13:		// RSrecv()
				// `lԍ
				printf("input CH(0-3) >> ");
				gets_s(chBuf, sizeof(chBuf));
				inPortNum = atoi(chBuf);

				// MTCY
				printf("input recv size >> ");
				gets_s(chBuf, sizeof(chBuf));
				inRecvSize = atoi(chBuf);

				// `lԍ
				printf("input Timeout(msec) >> ");
				gets_s(chBuf, sizeof(chBuf));
				dwTimeout = atol(chBuf);

				memset(pRecvBuff, 0, 1024);

				inRet = Tiny_RSrecv( inPortNum, pRecvBuff, inRecvSize, dwTimeout, &cDummy);
				printf("I$ Tiny_RSrecv() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 14:		// RSclear()
				// `lԍ
				printf("input CH(0-3) >> ");
				gets_s(chBuf, sizeof(chBuf));
				inPortNum = atoi(chBuf);

				inRet = Tiny_RSclear( inPortNum );
				printf("I$ Tiny_RSclear() result[%d] \n", inRet);
				break;

			// -------------------------------------------------------------------------------------------
			case 20:		// debug_info()
				Tiny_RSdebug_info();
				break;

			// -------------------------------------------------------------------------------------------
			default:
				printf("--<< Menu >>----------------------------------\n");
				printf("-- 1  : EhOpen()      | 2  : EhClose()        \n");
				printf("-- 3  : EhRqState()   |                       \n");
				printf("-- 10 : RSinit()      | 11 : RSterm()         \n");
				printf("-- 12 : RSsend()      | 13 : RSrecv()         \n");
				printf("-- 14 : RSclear()     |                       \n");
				printf("-- 20 : debug_info()  |                       \n");
				printf("-- 99 : Program end                           \n");
				printf("----------------------------------------------\n");
				break;

			// -------------------------------------------------------------------------------------------
		}

	}

	// {Xbh̏Iʒm
	gInit.htPoll1	= NULL_RTHANDLE;
}
